#ifndef ANIMATION_SPRITE_H
#define ANIMATION_SPRITE_H

#include <raylib.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
    Texture2D texture;
    Vector2 dimentions;
    
    Rectangle sourceRect;
    Vector2 size;
    float rotation;
    float scale;
    
    int frameCount;
    int currentFrame;

    float speed;
    float time;
} sprite_animation_t, *SpriteAnimation;

SpriteAnimation CreateSpriteAnimation(Texture2D texture, Vector2 sprite_texture_dimentions, Vector2 sprite_size, float rotation, float scale, int frameCount, float speed);

void UpdateSpriteAnimation(SpriteAnimation spriteAnimation, float dt);

void DrawSpriteAnimation(SpriteAnimation spriteAnimation, Vector2 position);

void DestroySpriteAnimation(SpriteAnimation spriteAnimation);

#ifdef __cplusplus
}
#endif

#endif // ANIMATION_SPRITE_H
